"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
}
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var globals_1 = require("./globals");
exports.MODAL_IFRAME_NAME = 'app-modal-iframe';
exports.REPLACE_STATE_MESSAGE = 'Shopify.API.replaceState';
var ReactShopifyAppRoutePropagator = /** @class */ (function (_super) {
    __extends(ReactShopifyAppRoutePropagator, _super);
    function ReactShopifyAppRoutePropagator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReactShopifyAppRoutePropagator.prototype.componentDidMount = function () {
        this.propagateLocation();
    };
    ReactShopifyAppRoutePropagator.prototype.componentDidUpdate = function () {
        this.propagateLocation();
    };
    ReactShopifyAppRoutePropagator.prototype.propagateLocation = function () {
        var location = this.props.location;
        var selfWindow = globals_1.getSelfWindow();
        var topWindow = globals_1.getTopWindow();
        var renderedInTheTopWindow = selfWindow === topWindow;
        var renderedInAModal = selfWindow.name === exports.MODAL_IFRAME_NAME;
        if (renderedInTheTopWindow || renderedInAModal) {
            return;
        }
        var normalizedLocation = getNormalizedURL(location);
        /*
          We delete this param that ends up unnecassarily stuck on
          the iframe due to oauth when propagating up.
        */
        normalizedLocation.searchParams.delete('hmac');
        var pathname = normalizedLocation.pathname, search = normalizedLocation.search, hash = normalizedLocation.hash;
        var data = JSON.stringify({
            message: exports.REPLACE_STATE_MESSAGE,
            data: { location: "" + pathname + search + hash },
        });
        topWindow.postMessage(data, '*');
    };
    ReactShopifyAppRoutePropagator.prototype.render = function () {
        return null;
    };
    return ReactShopifyAppRoutePropagator;
}(react_1.default.PureComponent));
exports.default = ReactShopifyAppRoutePropagator;
function getNormalizedURL(location) {
    var origin = globals_1.getOrigin();
    if (typeof location === 'string') {
        return new URL(location, origin);
    }
    var pathname = location.pathname, search = location.search, hash = location.hash;
    return new URL("" + pathname + search + hash, origin);
}
